osgi – 如何设置正确的equinox安装

2019-06-11
我用谷歌搜索了几个小时,但我找不到任何有用的东西.
我已经开发了一些OSGi包,现在我想在equinox容器中的 Eclipse IDE之外运行它们,但它总是引发异常:

!SESSION 2011-01-03 14:26:58.958 -----------------------------------------------
eclipse.buildId=unknown
java.version=1.6.0_20
java.vendor=Sun Microsystems Inc.
BootLoader constants: OS=win32, ARCH=x86_64, WS=win32, NL=de_CH
Framework arguments:  -Dosgi.clean=true -Declipse.ignoreApp=true -Dosgi.noShutdown=true -console;
Command-line arguments:  -consoleLog -Dosgi.clean=true -Declipse.ignoreApp=true -Dosgi.noShutdown=true -console;

!ENTRY org.eclipse.osgi 4 0 2011-01-03 14:26:59.567
!MESSAGE Error starting bundle: initial@reference:file:javax.transaction_1.1.1.v201006150915.jar/
!STACK 0
org.osgi.framework.BundleException: A fragment bundle cannot be started: javax.transaction_1.1.1.v201006150915 [49]
        at org.eclipse.osgi.framework.internal.core.BundleFragment.startWorker(BundleFragment.java:228)
        at org.eclipse.osgi.framework.internal.core.AbstractBundle.start(AbstractBundle.java:284)
        at org.eclipse.core.runtime.adaptor.EclipseStarter.startBundle(EclipseStarter.java:1133)
        at org.eclipse.core.runtime.adaptor.EclipseStarter.startBundles(EclipseStarter.java:1126)
        at org.eclipse.core.runtime.adaptor.EclipseStarter.loadBasicBundles(EclipseStarter.java:646)
        at org.eclipse.core.runtime.adaptor.EclipseStarter.startup(EclipseStarter.java:301)
        at org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:175)
        at org.eclipse.core.runtime.adaptor.EclipseStarter.main(EclipseStarter.java:150)
init dd core...

!ENTRY org.eclipse.osgi 4 0 2011-01-03 14:26:59.773
!MESSAGE Bundle javax.transaction_1.1.1.v201006150915 [49] is not active.

(“init dd core …”文本来自我的项目.)

我有以下文件结构:

+configuration
 +config.ini
+ch.thobens.dd.commands_1.0.0.jar
+ch.thobens.dd.common.items_1.0.0.jar
+ch.thobens.dd.core_1.0.0.jar
+ch.thobens.dd.game_1.0.0.jar
+javax.transaction_1.1.1.v201006150915.jar
+org.eclipse.core.contenttype_3.4.100.v20100505-1235.jar
+org.eclipse.core.jobs_3.5.0.v20100515.jar
+org.eclipse.core.runtime.compatibility.auth_3.2.200.v20100517.jar
+org.eclipse.core.runtime.compatibility.registry_3.3.0.v20100520/runtime_registry_compatibility.jar
+org.eclipse.core.runtime_3.6.0.v20100505.jar
+org.eclipse.equinox.app_1.3.0.v20100512.jar
+org.eclipse.equinox.common_3.6.0.v20100503.jar
+org.eclipse.equinox.preferences_3.3.0.v20100503.jar
+org.eclipse.equinox.registry_3.5.0.v20100503.jar
+org.eclipse.osgi.services_3.2.100.v20100503.jar
+org.eclipse.osgi_3.6.0.v20100517.jar

我的config.ini文件包含以下内容:

osgi.bundles=javax.transaction_1.1.1.v201006150915.jar@start, org.eclipse.core.contenttype_3.4.100.v20100505-1235.jar@start, org.eclipse.core.jobs_3.5.0.v20100515.jar@start, org.eclipse.core.runtime.compatibility.auth_3.2.200.v20100517.jar@start,org.eclipse.core.runtime.compatibility.registry_3.3.0.v20100520/runtime_registry_compatibility.jar@start, org.eclipse.core.runtime_3.6.0.v20100505.jar@start, org.eclipse.equinox.app_1.3.0.v20100512.jar@start, org.eclipse.equinox.common_3.6.0.v20100503.jar@2:start, org.eclipse.equinox.preferences_3.3.0.v20100503.jar@start, org.eclipse.equinox.registry_3.5.0.v20100503.jar@start, org.eclipse.osgi.services_3.2.100.v20100503.jar@start, ch.thobens.dd.commands_1.0.0.jar@start, ch.thobens.dd.common.items_1.0.0.jar@start, ch.thobens.dd.core_1.0.0.jar@start, ch.thobens.dd.game_1.0.0.jar@1:start
eclipse.ignoreApp=true
osgi.noShutdown=true

此处列出的捆绑包与在运行配置中选择“添加所需插件”时选择的捆绑包相同.如果我从Eclipse PDE运行这些包,它可以正常工作.

此外,运行命令之间没有区别

java -jar org.eclipse.osgi_3.6.0.v20100517.jar -consoleLog -Dosgi.clean=true -Declipse.ignoreApp=true -Dosgi.noShutdown=true

当我使用equinox启动器(通过eclipse.exe).

谢谢你的帮助

我找到了解决方案(通过eclipse产品导出器):

javax.transaction_1.1.1.v201006150915.jar本身不是OSGi包,它是OSGi框架扩展.

我不得不更改config.ini文件:

>删除该条目
javax_transaction包中的
物业osgi.bundles
>添加以下行:

osgi.framework.extensions = javax.transaction_1.1.1.v201006150915.jar